import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;

public class Jump {
	public static SortedSet<Integer> pos = new TreeSet<Integer>(); 
	public static Set<Integer> visitied = new HashSet<Integer>();
	
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n;
		while((n = sc.nextInt()) != 0) {
			int[] line = new int[n];
			for(int i = 0; i < n; i++) {
				line[i] = sc.nextInt();
			}
			visitied.clear();
			pos.add(0);
			int max = 0;
			while(!pos.isEmpty()) {
				int from = pos.first();
				pos.remove(from);
				visitied.add(from);
				if(from > max) max = from;
				for(int i = 0; i <= from - line[from];i++) {
					if(visitied.contains(i)) continue;
					if (canJump(from, i, line)) {
						pos.add(i);
					}
				}
				for(int i = from + line[from]; i < n;i++) {
					if(visitied.contains(i)) continue;
					if (canJump(from, i, line)) {
						pos.add(i);
					}
				}
			}
			System.out.println(max);
		}
		sc.close();
	}
	
	public static boolean canJump(int from, int to, int[] line) {
		int diff = 0;
		if(from < to) diff = to - from;
		else diff = from - to;
		return (line[from] + line[to]) == diff;
	}
}
